import VectorLayer from "ol/layer/Vector";
import VectorSource from "ol/source/Vector";
import Draw from 'ol/interaction/Draw';
import {
	Fill,
	Stroke,
	Style,
	Text as TextStyle
} from "ol/style";
import CircleStyle from "ol/style/Circle";
import {
	getArea,
	getLength
} from 'ol/sphere.js';
import {
	LineString,
	Point
} from "ol/geom";


const serverUrl = 'https://app.hycdyzt.com';
const geoserverUrl = 'http://47.109.60.82:8080';
const mgServerUrl = 'http://47.109.60.82:9989/openApi'
const globalMap = {
	map: null
}
const formatArea = function(polygon) {
	let area = getArea(polygon, {
		projection: 'EPSG:4326'
	});
	area = area * 0.0015
	let output;
	if (area > 10000) {
		output = Math.round((area / 10000) * 100) / 100 + ' ' + '万亩';
	} else {
		output = Math.round(area * 100) / 100 + ' ' + '亩';
	}
	return output;
};
const formatLength = function(line) {
	const length = getLength(line, {
		projection: 'EPSG:4326'
	});
	let output;
	if (length > 100) {
		output = Math.round((length / 1000) * 100) / 100 + ' ' + 'km';
	} else {
		output = Math.round(length * 100) / 100 + ' ' + 'm';
	}
	return output;
};

const generateStyle = (feature, {
	fillOpt,
	strokeOpt,
	withNode
}) => {
	let area = 0;
	const geom = feature.getGeometry();
	let lineStyle;
	if (geom.getType() === 'Polygon') {
		area = formatArea(geom);
		const lineString = new LineString(geom.getCoordinates()[0]);
		const length = formatLength(lineString);
		lineStyle = [new Style({
			geometry: lineString,
			text: new TextStyle({
				text: length,
				"textBaseline": "middle",
				"font": "bold 10px/1 Verdana",
				"offsetX": 0,
				"offsetY": 0,
				fill: new Fill({
					color: 'rgba(255, 255, 255, 1)',
				}),
				stroke: new Stroke({
					width: 2,
					color: 'rgba(0, 0, 0, 1)',
				}),
				"placement": "line",
				"maxAngle": 0.7853981633974483,
				"overflow": true,
				"rotation": 0
			})
		}), ...(withNode ? geom.getCoordinates()[0]?.map(coordinates => {
			return new Style({
				geometry: new Point(coordinates),
				image: new CircleStyle({
					fill: new Fill({
						color: '#0ff'
					}),
					radius: 2
				})
			})
		}) : [])]
	}
	return [new Style({
		fill: new Fill({
			...fillOpt
		}),
		stroke: new Stroke({
			width: 2,
			...strokeOpt
		}),
		text: geom.getType() !== 'Polygon' ? undefined : new TextStyle({
			text: area,
			"textBaseline": "middle",
			"font": "bold 10px/1 Verdana",
			"offsetX": 0,
			"offsetY": 0,
			fill: new Fill({
				color: 'rgba(0, 0, 0, 0.9)',
			}),
			"placement": "point",
			"maxAngle": 0.7853981633974483,
			"overflow": true,
			"rotation": 0
		})
	}), ...(lineStyle || [])].filter(item => item);
}

const startMeasure = (map, callback) => {
	map.removeLayer(map.getAllLayers().find(l => l.get('id') === 'draw-layer'));
	const source = new VectorSource();

	const vector = new VectorLayer({
		id: 'draw-layer',
		source: source,
		zIndex: 9999,
		style: feature => {
			return generateStyle(feature, {
				fillOpt: {
					color: 'rgba(255, 255, 255, 0.4)',
				},
				strokeOpt: {
					color: '#ffcc33',
					width: 2,
				}
			})
		}

	});

	const draw = new Draw({
		source: source,
		type: 'Polygon',
		stopClick: true,
		freehand: true,
		style: function(feature) {
			return generateStyle(feature, {
				fillOpt: {
					color: 'rgba(255, 255, 255, 0.2)',
				},
				strokeOpt: {
					color: 'rgba(0, 0, 0, 0.5)',
					lineDash: [10, 10],
					width: 2,
				}
			})
		},
	});
	map.addInteraction(draw);

	draw.on('drawend', function() {
		map.addLayer(vector)
		map.removeInteraction(draw);
		callback();
	});
}

//定义一些常量
var x_PI = 3.14159265358979324 * 3000.0 / 180.0;
var PI = 3.1415926535897932384626;
var a = 6378245.0;
var ee = 0.00669342162296594323;
/**
 * 百度坐标系 (BD-09) 与 火星坐标系 (GCJ-02)的转换
 * 即 百度 转 谷歌、高德
 */
function bd09togcj02(bd_lon, bd_lat) {
	var x_pi = 3.14159265358979324 * 3000.0 / 180.0;
	var x = bd_lon - 0.0065;
	var y = bd_lat - 0.006;
	var z = Math.sqrt(x * x + y * y) - 0.00002 * Math.sin(y * x_pi);
	var theta = Math.atan2(y, x) - 0.000003 * Math.cos(x * x_pi);
	var gg_lng = z * Math.cos(theta);
	var gg_lat = z * Math.sin(theta);
	return [gg_lng, gg_lat]
}
/**
 * 火星坐标系 (GCJ-02) 与百度坐标系 (BD-09) 的转换
 * 即谷歌、高德 转 百度
 */
function gcj02tobd09(lng, lat) {
	var z = Math.sqrt(lng * lng + lat * lat) + 0.00002 * Math.sin(lat * x_PI);
	var theta = Math.atan2(lat, lng) + 0.000003 * Math.cos(lng * x_PI);
	var bd_lng = z * Math.cos(theta) + 0.0065;
	var bd_lat = z * Math.sin(theta) + 0.006;
	return [bd_lng, bd_lat]
}
/**
 * WGS84转GCj02
 */
function wgs84togcj02(lng, lat) {
	if (out_of_china(lng, lat)) {
		return [lng, lat]
	} else {
		var dlat = transformlat(lng - 105.0, lat - 35.0);
		var dlng = transformlng(lng - 105.0, lat - 35.0);
		var radlat = lat / 180.0 * PI;
		var magic = Math.sin(radlat);
		magic = 1 - ee * magic * magic;
		var sqrtmagic = Math.sqrt(magic);
		dlat = (dlat * 180.0) / ((a * (1 - ee)) / (magic * sqrtmagic) * PI);
		dlng = (dlng * 180.0) / (a / sqrtmagic * Math.cos(radlat) * PI);
		var mglat = lat + dlat;
		var mglng = lng + dlng;
		return [mglng, mglat]
	}
}
/**
 * GCJ02 转换为 WGS84
 */
function gcj02towgs84(lng, lat) {
	if (out_of_china(lng, lat)) {
		return [lng, lat]
	} else {
		var dlat = transformlat(lng - 105.0, lat - 35.0);
		var dlng = transformlng(lng - 105.0, lat - 35.0);
		var radlat = lat / 180.0 * PI;
		var magic = Math.sin(radlat);
		magic = 1 - ee * magic * magic;
		var sqrtmagic = Math.sqrt(magic);
		dlat = (dlat * 180.0) / ((a * (1 - ee)) / (magic * sqrtmagic) * PI);
		dlng = (dlng * 180.0) / (a / sqrtmagic * Math.cos(radlat) * PI);
		var mglat = lat + dlat;
		var mglng = lng + dlng;
		return [lng * 2 - mglng, lat * 2 - mglat]
	}
}

function transformlat(lng, lat) {
	var ret = -100.0 + 2.0 * lng + 3.0 * lat + 0.2 * lat * lat + 0.1 * lng * lat + 0.2 * Math.sqrt(Math.abs(lng));
	ret += (20.0 * Math.sin(6.0 * lng * PI) + 20.0 * Math.sin(2.0 * lng * PI)) * 2.0 / 3.0;
	ret += (20.0 * Math.sin(lat * PI) + 40.0 * Math.sin(lat / 3.0 * PI)) * 2.0 / 3.0;
	ret += (160.0 * Math.sin(lat / 12.0 * PI) + 320 * Math.sin(lat * PI / 30.0)) * 2.0 / 3.0;
	return ret
}

function transformlng(lng, lat) {
	var ret = 300.0 + lng + 2.0 * lat + 0.1 * lng * lng + 0.1 * lng * lat + 0.1 * Math.sqrt(Math.abs(lng));
	ret += (20.0 * Math.sin(6.0 * lng * PI) + 20.0 * Math.sin(2.0 * lng * PI)) * 2.0 / 3.0;
	ret += (20.0 * Math.sin(lng * PI) + 40.0 * Math.sin(lng / 3.0 * PI)) * 2.0 / 3.0;
	ret += (150.0 * Math.sin(lng / 12.0 * PI) + 300.0 * Math.sin(lng / 30.0 * PI)) * 2.0 / 3.0;
	return ret
}
/**
 * 判断是否在国内，不在国内则不做偏移
 */
function out_of_china(lng, lat) {
	return (lng < 72.004 || lng > 137.8347) || ((lat < 0.8293 || lat > 55.8271) || false);
}



export default {
	serverUrl,
	geoserverUrl,
	globalMap,
	mgServerUrl,
	startMeasure,
	tempToken: '',
	formatArea,
	formatLength,
	generateStyle,
	tempUserInfo: '',
	gcj02towgs84
}